/*
 * dma_engine.h
 *
 *  Created on: Aug 25, 2020
 *      Author: tom
 */

#ifndef DMA_ENGINE_H_
#define DMA_ENGINE_H_

#include "dma_engine_types.h"
#include "flipcie_priv.h"

extern int dma_engine_probe(struct pci_dev *pci_devp,fli_cam_data_t *pDev);
extern int dma_engine_remove(struct pci_dev *pPciDev,fli_cam_data_t *pDev);
extern int dma_engine_start_xfer(fli_cam_data_t *pDev, fli_sg_mapping_t *pSGMap);
extern int dma_engine_stop_xfer(fli_cam_data_t *pDev, fli_sg_mapping_t *pSGMap);
extern int dma_engine_is_xfer_complete(fli_cam_data_t *pDev, fli_sg_mapping_t *pSGMap);
extern void dma_engine_dump_regs(fli_cam_data_t *pDev);

extern int32_t dma_build_contiguous_sgdescriptor_list(fli_cam_data_t *pDev, fli_sg_mapping_t *pSGMap);
extern void    dma_free_contiguous_sgdescriptor_list(fli_cam_data_t *pDev, fli_sg_mapping_t *pSGMap);


#endif /* DMA_ENGINE_H_ */
