/*
 * flipcie_dma.h
 *
 *  Created on: Aug 21, 2020
 *      Author: tom
 */

#ifndef FLIPCIE_DMA_H_
#define FLIPCIE_DMA_H_

#include "flipcie_priv.h"
#include "flipcie_ioctl.h"


extern int flidma_probe(struct pci_dev *pci_devp, fli_cam_data_t *pCamDev);
extern int flidma_remove(struct pci_dev *pPciDev, fli_cam_data_t *pCamDev);

extern int flidma_create_descriptors(fli_cam_data_t *pDev, FLI_CAM_IOCTL_STREAM_INIT_T *pStreamInit);
extern int flidma_free_descriptors(fli_cam_data_t *pDev);

extern int flidma_start(fli_cam_data_t *pDev, fli_sg_mapping_t *pSGMap);
extern int flidma_stop(fli_cam_data_t *pDev, fli_sg_mapping_t *pSGMap);

extern int flidma_wait_for_complete(fli_cam_data_t *pDev, fli_sg_mapping_t *pSGMap, uint64_t uiTimeoutMS);


#endif /* FLIPCIE_DMA_H_ */
